/*
 * Copyright (c) 2011 PonySDK
 *  Owners:
 *  Luciano Broussal  <luciano.broussal AT gmail.com>
 *	Mathieu Barbier   <mathieu.barbier AT gmail.com>
 *	Nicolas Ciaravola <nicolas.ciaravola.pro AT gmail.com>
 *  
 *  WebSite:
 *  http://code.google.com/p/pony-sdk/
 * 
 * Licensed under the Apache License, Version 2.0 (the "License"); you may not
 * use this file except in compliance with the License. You may obtain a copy of
 * the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS, WITHOUT
 * WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. See the
 * License for the specific language governing permissions and limitations under
 * the License.
 */

package com.ponysdk.impl.theme;

public interface PonySDKTheme {

    String HEADER = "pony-Header";

    String HEADER_LOGO = "pony-Header-Logo";

    String HEADER_ACCOUNT_MENU = "pony-Header-AccountMenu";

    String HEADER_ACCOUNT_MENU_SELECTED = "pony-Header-AccountMenu-Selected";

    String HEADER_ACCOUNT_MENU_POPUP = "pony-Header-AccountMenu-Popup";

    String HEADER_ACCOUNT_MENU_POPUP_USER_NAME = "pony-Header-AccountMenu-Popup-UserName";

    String HEADER_ACCOUNT_MENU_POPUP_USER_LOGIN = "pony-Header-AccountMenu-Popup-UserLogin";

    String FOOTER = "pony-Footer";

    String LIST = "List";

    String COMPLEXLIST = "pony-ComplexList";
    String COMPLEXLIST_BOTTOM_LIST = "pony-ComplexList-bottomList";

    String COMPLEXLIST_DETAILS_PLUS = "pony-ComplexList-Details-Plus";

    String COMPLEXLIST_DETAILS_MINUS = "pony-ComplexList-Details-Minus";

    String COMPLEXLIST_HEADERCELLRENDERER_DATERANGE = "pony-ComplexList-HeaderCellRenderer-DateRange";

    String COMPLEXLIST_HEADERCELLRENDERER_MAINCHECKBOX = "pony-ComplexList-HeaderCellRenderer-MainCheckBox";

    String COMPLEXLIST_COLUMNHEADER_COMPLEX = "pony-ComplexList-ColumnHeader";
    String COMPLEXLIST_HEADERCELLRENDERER_COMPLEX = "pony-ComplexList-ComplexHeader";
    String COMPLEXLIST_HEADERCELLRENDERER_COMPLEX_SORTABLE = "sortable";
    String COMPLEXLIST_HEADERCELLRENDERER_COMPLEX_SORTABLE_NONE = "none";
    String COMPLEXLIST_HEADERCELLRENDERER_COMPLEX_SORTABLE_ASCENDING = "ascending";
    String COMPLEXLIST_HEADERCELLRENDERER_COMPLEX_SORTABLE_DESCENDING = "descending";

    String SIMPLELIST = "pony-SimpleList";
    String SIMPLELIST_ROW = "pony-SimpleList-Row";
    String SIMPLELIST_SUBROW = "pony-SimpleList-SubRow";
    String SIMPLELIST_SELECTEDROW = "pony-SimpleList-Row-Selected";

    String ORACLE_ITEM = "pony-Oracle-Item";

    String ORACLE_LIST_BOX_SELECTED = "pony-OracleListBox-Selected";

    String ORACLE_POPUP_PANEL = "pony-Oracle-PopupPanel";

    String ORACLE_PAGINATION = "pony-Oracle-pagination";

    String ORACLE_ARROW = "pony-Oracle-Arrow";

    String ORACLE_ARROW_UP = "pony-Oracle-Arrow-Up";

    String ORACLE_ARROW_DOWN = "pony-Oracle-Arrow-Down";

    String ORACLE_TEXT_BOX = "pony-Oracle-TextBox";

    String PAGE = "pony-Page";

    String PAGE_BODY = "pony-Page-Body";

    String PAGE_HEADER = "pony-Page-Header";

    String PAGE_HEADER_CAPTION = "pony-Page-Header-Caption";

    String PAGE_NAVIGATION = "pony-Page-Navigation";
    String PAGE_NAVIGATION_ITEM_SELECTED = "pony-Page-Navigation-selectedItem";

    String MENUBAR = "pony-MenuBar";

    String MENUBAR_LIGHT = "pony-MenuBar-Light";

    String TOOLBAR = "pony-Toolbar";

    String FLOATING_TOOLBAR = "pony-Toolbar-Floating";

    String TOOLBAR_SEPARATOR = "pony-Toolbar-Separator";

    String BUTTON = "pony-PButton";

    String BUTTON_BLACK = "pony-PButton black";

    String BUTTON_GRAY = "pony-PButton gray";

    String BUTTON_WHITE = "pony-PButton white";

    String BUTTON_ORANGE = "pony-PButton orange";

    String BUTTON_RED = "pony-PButton red";

    String BUTTON_BLUE = "pony-PButton blue";

    String BUTTON_ROSY = "pony-PButton rosy";

    String BUTTON_GREEN = "pony-PButton green";

    String BUTTON_PINK = "pony-PButton pink";

    String FILL_COLUMN = "pony-ComplexList-Fill-column";

    String LOGIN_PAGE = "pony-LoginPage";

    String LOGIN_PAGE_LOGIN_TEXTBOX = "pony-LoginPage-LoginTextBox";

    String LOGIN_PAGE_PASSWORD_TEXTBOX = "pony-LoginPage-PasswordTextBox";

    String LOGIN_PAGE_SUBMIT_BUTTON = "pony-LoginPage-SubmitButton";

    String LOGIN_PAGE_VERSION_INFORMATION = "pony-LoginPage-VersionInformation";

    String LOGIN_PAGE_LOGO = "pony-LoginPage-Logo";

    String NOTIFICATION = "pony-notification";

    String NOTIFICATION_HUMANIZED = "humanized";

    String NOTIFICATION_WARNING = "warning";

    String NOTIFICATION_ERROR = "error";

    String NOTIFICATION_TRAY = "tray";

    String LOG_CONSOLE = "pony-LogConsolePanel";

    String LOG_CONSOLE_ACTIONS = "pony-LogConsolePanel-ActionPanel";

    String LOG_CONSOLE_LOGS = "pony-LogConsolePanel-LogsPanel";

    String CLOSABLE_DIALOGBOX = "pony-closable-dialog-box";

    String CLOSABLE_DIALOGBOX_HEADER = "header";

    String CLOSABLE_DIALOGBOX_LAYOUT = "layout";

    String CLOSABLE_DIALOGBOX_CAPTION = "caption";

    String CLOSABLE_DIALOGBOX_CLOSE = "close";

    String CLOSABLE_DIALOGBOX_CONTENT = "content";

    String DIALOGBOX = "pony-DialogBox";

    String DIALOGBOX_CONTROLS = "dialogControls";

    String FORM = "pony-Form";

    String FORM_FORMFIELD_COMPONENT = "pony-Form-FormField-Component";

    String MULTISELECTLISTBOX = "pony-MultiSelectListBox";
    String MULTISELECTLISTBOX_FOCUS = "pony-MultiSelectListBox-Focus";
    String MULTISELECTLISTBOX_VALUE_ITEM = "pony-MultiSelectListBox-ValueItem";
    String MULTISELECTLISTBOX_VALUE_TEXT = "pony-MultiSelectListBox-ValueText";
    String MULTISELECTLISTBOX_SELECTED_PANEL = "pony-MultiSelectListBox-SelectedPanel";
    String MULTISELECTLISTBOX_SELECTED_ITEMS_PANEL = "pony-MultiSelectListBox-SelectedItemsPanel";
    String MULTISELECTLISTBOX_POPUP_PANEL = "pony-MultiSelectListBox-PopupPanel";
    String MULTISELECTLISTBOX_ITEMS_SELECTION_PANEL = "pony-MultiSelectListBox-ItemsSelectionPanel";
    String MULTISELECTLISTBOX_SHOW_SELECTION_PANEL_BUTTON = "pony-MultiSelectListBox-ShowSelectionPanelButton";
    String MULTISELECTLISTBOX_CARET = "pony-MultiSelectListBox-Caret";

    String BREADCRUMBS = "pony-BreadCrumbs";

    String TWIN_LISTBOX = "pony-TwinListBox";
    String TWIN_LISTBOX_LEFT_LISTBOX = "pony-TwinListBox-Left-ListBox";
    String TWIN_LISTBOX_RIGHT_LISTBOX = "pony-TwinListBox-Right-ListBox";
    String TWIN_LISTBOX_SWITCH_BUTTON = "pony-TwinListBox-Switch-ListBox";

}
